<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class PerfacessparcOperadorRepository {
    protected $entityManager;

    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    public function getMaxNrPerfAcessParc () {
      $selecMax = $this->entityManager->getConnection()->fetchAll(Utilities\Query::RETORNA_MAXNRPERFACESSOPARC);
		if(empty($selecMax)){
			return 1;
		}
		return $selecMax;
    }

    public function salvaPerfilAcessoParcOperador($nrperfacessparc, $nrorg, $idativo, $dtvalperfilparc,
     $nrparcnegocio, $nrperfilacesso){

     	$params = array(
			'NRPERFACESSPARC' => $nrperfacessparc,
			'NRORG' => $nrorg,
			'IDATIVO'=>$idativo,
			'DTVALPERFILPARC'=>$dtvalperfilparc,
			'NRPARCNEGOCIO'=>$nrparcnegocio,
			'NRPERFILACESSO'=>$nrperfilacesso
		);
     	
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERT_PERFACESSPARCOPERADOR, $params);
  	
    }

    public function getAllPerfAcesso($nrorg, $nrperfilacesso) {
    	
    	return $this->entityManager->getConnection()->fetchAll("SELECT OPERADOR.CDOPERADOR, OPERADOR.NMOPERADOR, PERFACESSPARC.* FROM PERFACESSPARC JOIN OPERADOR ON
           (PERFACESSPARC.NRPARCNEGOCIO = OPERADOR.NRPARCNEGOCIO AND PERFACESSPARC.NRORG = OPERADOR.NRORG )
            WHERE PERFACESSPARC.NRPERFILACESSO = {$nrperfilacesso} AND PERFACESSPARC.NRORG = {$nrorg}");
    }

    public function deletePerfAcessoParc($nrperfacessparc){

    	$params = array('NRPERFIL' => $nrperfacessparc);
    	return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_PERFACESSPARC, $params);
    	
    }

    public function findOperadorInGroup($nrparcnegocio, $nrperfilacesso){
    	$params = array(':NRPERFILACESSO' => $nrperfilacesso,
    					':NRPARCNEGOCIO'=>$nrparcnegocio
    	);
    	return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_OPER_IN_PERFILACESSO, $params);

    }
}